@use '../../../global/styles/styles-variables' as *;
@use '../../../global/styles/utilities' as *;
@use './styles/progress-list-item.variations' as variations;
@use './styles/progress-list-item.variables' as *;
@use './../../../global/styles/utilities' as *;

:host {
  @include digi-progress-list-item--variables;

  .digi-progress-list-item {
    $base: &;
    --INDICATOR--LINE--COLOR: var(
      --digi--progress-list-item--indicator--color--tertiary
    );

    display: flex;
    flex-direction: row;
    font-family: var(--digi--global--typography--font-family--default);
    gap: var(--digi--padding--largest);

    &--primary {
      @include variations.primary;
    }

    &--secondary {
      @include variations.secondary;
    }

    &--tertiary {
      @include variations.tertiary;
    }

    &--done {
      --INDICATOR--LINE--COLOR: var(--INDICATOR--CIRCLE--COLOR);

      &#{$base}__indicator {
        &--icon {
          background: var(--INDICATOR--CIRCLE--COLOR);

          &--digi {
            max-height: 15px;
            max-width: 15px;
            min-height: 1.6em;
          }
        }

        &--circle {
          background-color: var(--INDICATOR--CIRCLE--COLOR);
        }

        &--line {
          border-left: var(--digi--process-list-item--indicator--border--width)
            solid var(--INDICATOR--LINE--COLOR);
        }
      }
    }

    &--current {
      &#{$base}__indicator {
        &--icon {
          background: var(--INDICATOR--CIRCLE--COLOR);
          height: 32px;
          width: 32px;

          &--digi {
            min-height: 2em;
          }
        }

        &--circle {
          background-color: var(--INDICATOR--CIRCLE--COLOR);
          box-shadow:
            inset 0 0 0 4px var(--INDICATOR--CIRCLE--COLOR),
            inset 0 0 0 7px #fff;
          height: 32px;
          width: 100%;
        }

        &--line {
          border-left: var(--digi--process-list-item--indicator--border--width)
            dashed var(--INDICATOR--LINE--COLOR);
        }
      }
    }

    &--upcoming {
      --INDICATOR--CIRCLE--COLOR: var(--INDICATOR--LINE--COLOR);

      &#{$base}__indicator {
        &--circle,
        &--icon {
          border: var(--digi--process-list-item--indicator--border--width)
            dashed var(--INDICATOR--LINE--COLOR);
          box-shadow: none;
          width: 24px;
          height: 24px;
        }

        &--line {
          border-left: var(--digi--process-list-item--indicator--border--width)
            dashed var(--INDICATOR--LINE--COLOR);
        }
      }
    }

    &__indicator {
      align-items: center;
      display: flex;
      flex-basis: 32px;
      flex-direction: column;
      flex-shrink: 0;
      margin-left: 2px;
      margin-top: 3px;
      transform: translateY(2px);

      &--icon {
        height: 26px;
        width: 26px;
        border-radius: 16px;

        &--digi {
          color: var(--digi--color--icons--inverted);
          --digi--icon--color: var(--digi--color--icons--inverted);
          margin: auto;
          max-height: 18px;
          max-width: 18px;
        }
      }

      &--circle {
        border-radius: 16px;
        box-shadow: inset 0 0 0 6px var(--INDICATOR--CIRCLE--COLOR);
        display: block;
        flex-shrink: 0;
        height: 26px;
        width: 26px;
      }

      &--line {
        display: block;
        flex-grow: 1;
        margin-bottom: 4px;
        margin-top: 6px;
        width: 1px;
      }
    }

    &__wrapper {
      border-bottom: var(--digi--border-width--primary) solid
        var(--digi--color--border--neutral-2);
      margin-bottom: var(--digi--padding--medium);
      max-width: var(--digi--paragraph-width--medium);
      padding-bottom: var(--digi--padding--medium);
      width: 100%;

      &--last {
        border-bottom: none;
      }
    }

    &__header {
      &--heading {
        display: flex;
        margin: 0;

        &--title {
          color: var(--digi--color--text--primary);
          width: 100%;
          font-family: var(--digi--global--typography--font-family--default);
          font-size: var(--digi--progress-list-item--heading--font-size);
          font-weight: var(--digi--progress-list-item--heading--font-weight);

          &--expandable {
            cursor: pointer;

            &:hover,
            &:active {
              color: var(--digi--color--text--link);
              text-decoration: underline;
            }
          }
        }
      }

      &--button {
        align-items: center;
        background-color: transparent;
        border-radius: 0;
        border: none;
        color: var(--digi--color--text--link);
        cursor: pointer;
        display: flex;
        font-size: var(--digi--typography--body--font-size--desktop);
        justify-content: center;
        text-align: left;
        padding: 0;
        width: 100%;
      }

      &--button:focus-visible {
        @include digi--focus();
      }

      &--toggle {
        align-items: center;
        display: flex;
        padding: var(--digi-process-list-item--toggle--padding);

        &--expanded {
          .icon-slot {
            transform: rotate(180deg);
          }
        }

        .icon-slot {
          transition: transform 0.25s;
          --digi--icon--color: var(--digi--color--text--link);
          --digi--icon--width: var(--digi--progress-list-item---icon--size);
          --digi--icon--height: var(--digi--progress-list-item---icon--size);
        }

        &--text {
          padding-left: var(--digi--padding--smaller);
          text-wrap: none;
          @media screen and (max-width: $digi--breakpoint--medium-below) {
            display: none;
          }
        }
      }
    }

    &__content {
      box-sizing: border-box;
      display: block;

      > div {
        padding: var(--digi--gutter--largest-2);
        box-sizing: border-box;
        max-width: var(--digi--paragraph-width--medium);
      }

      &--expandable {
        margin-right: 44px;
      }

      &--hidden {
        display: none;
      }
    }

    &--last {
      &#{$base}__indicator {
        &--line {
          display: none;
        }
      }
    }
  }
}
.visually-hidden {
  @include digi--a11y--sr-only;
}
